<?php

class Fsqlfilelock

{

	var $handle;

	var $filepath;

	var $lock;

	var $rcount = 0;

	var $wcount = 0;



	function Fsqlfilelock($filepath)

	{

		$this->filepath = $filepath;

		$this->handle = null;

		$this->lock = 0;

	}



	function getHandle()

	{

		return $this->handle;

	}



	function acquireRead()

	{

		if($this->lock !== 0 && $this->handle !== null) {  /* Already have at least a read lock */

			$this->rcount++;

			return true;

		}               

		else if($this->lock === 0 && $this->handle === null) /* New lock */

		{

			$this->handle = fopen($this->filepath, 'rb');

			if($this->handle)

			{

				flock($this->handle, LOCK_SH);

				$this->lock = 1;

				$this->rcount = 1;

				return true;

			}

		}

            

		return false;     

	}



	function acquireWrite()

	{

		if($this->lock === 2 && $this->handle !== null)  /* Already have a write lock */

		{

			$this->wcount++;

			return true;

		}

		else if($this->lock === 1 && $this->handle !== null)  /* Upgrade a lock*/

		{

			flock($this->handle, LOCK_EX);

			$this->lock = 2;

			$this->wcount++;

			return true;

		}                

		else if($this->lock === 0 && $this->handle === null) /* New lock */

		{

			touch($this->filepath); // make sure it exists

			$this->handle = fopen($this->filepath, 'r+b');

			if($this->handle)

			{

				flock($this->handle, LOCK_EX);

				$this->lock = 2;

				$this->wcount = 1;

				return true;

			}

		}



		return false;

	}



	function releaseRead()

	{

		if($this->lock !== 0 && $this->handle !== null)

		{

			$this->rcount--;



			if($this->lock === 1 && $this->rcount === 0) /* Read lock now empty */

			{	

				// no readers or writers left, release lock

				flock($this->handle, LOCK_UN);

				fclose($this->handle);

				$this->handle = null;

				$this->lock = 0;

			}

		}



		return true;

	}



	function releaseWrite()

	{

		if($this->lock !== 0 && $this->handle !== null)

		{

			if($this->lock === 2) /* Write lock */

			{

				$this->wcount--;

				if($this->wcount === 0) // no writers left.

				{

					if($this->rcount > 0)  // only readers left.  downgrade lock.

					{

						flock($this->handle, LOCK_SH);

						$this->lock = 1;

					}

					else // no readers or writers left, release lock

					{

						flock($this->handle, LOCK_UN);

						fclose($this->handle);

						$this->handle = null;

						$this->lock = 0;

					}

				}

			}

		}



		return true;

	}

}