<?php



# Extend

require_once( 'Fsqltablecursor.php' );



class Fsqltable

{

	var $cursor = NULL;

	var $columns = NULL;

	var $entries = NULL;

	var $data_load =0;

	var $uncommited = false;



	function create($path_to_db, $table_name, $columnDefs)

	{

		$table = new Fsqltable;

		$table->columns = $columnDefs;

		return $table;

	}

	

	function exists() {

		return TRUE;

	}

	

	function getColumnNames() {

		return array_keys($this->getColumns());

	}

	

	function getColumns() {

		return $this->columns;

	}

	

	function setColumns($columns) {

		$this->columns = $columns;

	}

	

	function getCursor()

	{

		if($this->cursor == NULL)

			$this->cursor = new Fsqltablecursor;

		

		$this->cursor->entries = $this->entries;

		$this->cursor->num_rows = count($this->entries);

		$this->cursor->pos = 0;

		

		return $this->cursor;

	}

	

	function insertRow($data) {

		$this->entries[] = $data;

		$this->uncommited = true;

	}

	

	function updateRow($row, $data) {

		foreach($data as $key=> $value)

			$this->entries[$row][$key] = $value;

		$this->uncommited = true;

	}

	

	function deleteRow($row) {

		unset($this->entries[$row]);

		$this->uncommited = true;

	}

	

	function commit()

	{

		$this->uncommited = false;

	}

	

	function rollback()

	{

		$this->data_load = 0;

		$this->uncommited = false;

	}



	/* Unecessary for temporary tables */

	function readLock() { return true; }

	function writeLock() { return true; }

	function unlock() { return true; }

}