<!DOCTYPE html>

<html>

	<head>

		<title>CodeIgniter HMVC :: Eestikeelne õpetus</title>

		<meta name='description' content='CodeIgniter on üli-lihtne PHP Framework mis erineb teistest oma kõrge kiiruse ja väikese jalajälje poolest. Lisades CodeIgniter lahendusele ka wiredesignz-i poolt loodud HMVC laienduse on CodeIgniter hoopis uuel tasemel! Räägime sellest lähemalt.'>

		<meta name='author' content='Joonas Kolostov'>

		<meta charset='utf-8'>

		<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css'>

		<link rel='stylesheet' href='//cdnjs.cloudflare.com/ajax/libs/highlight.js/8.7/styles/default.min.css'>

		

		<script src='https://code.jquery.com/jquery-2.1.4.min.js'></script>

		<script src='//cdnjs.cloudflare.com/ajax/libs/highlight.js/8.7/highlight.min.js'></script>

		<script>

		$(document).ready(function() {

			$('pre code').each(function(i, block) {

				var tabs = String.fromCharCode(9).repeat(6);

				

				for( var i = 0; i < 20; i ++ )

				{

					$(this).html( $(this).html().replace(tabs, '') );

				}

				

				hljs.highlightBlock( block );

			});

		});

		</script>

	</head>

	<body>

		<div class='container'>

			<div class='row'>

				<!-- Kiirviited -->

				<div class='col-xs-12 col-lg-2'>

					<h3> Kiirviited </h3>

					<ul>

						<li> <a href='#install'> Installatsioon </a> </li>

						<li> <a href='#setup'> Seadistamine </a> </li>

						<li> <a href='#hmvc'> MX Liides (HMVC) </a> </li>

						<li> <a href='#fsql-ci-driver'> fSQL laiendus CI'le </a> </li>

						<li> <a href='#contact'> Kontakt </a> </li>

					</ul>

					<h3> Lisaks </h3>

					<ul>

						<li> <a href='http://web.zone.ee/fsql/' target='_blank'> fSQL failipõhine db </a> </li>

					</ul>

				</div>

				

				<!-- Sisu -->

				<div class='col-xs-12 col-lg-10'>

					<h1>CodeIgniter HMVC <small><br>EllisLab, British Columbia Institute of Technology, wiredesignz</small></h1>

					

					<a name='install'></a>

					<h2>Installatsioon</h2>

					<p>Alustuseks laadige viimane versioon CodeIgnitersit (v3.0.1) ametlikult kodulehelt <a href='http://www.codeigniter.com/' target='_blank'>codeigniter.com</a> ning 

					asetage arhiivist kasutad: application ja system ning fail index.php teile sobivasse kausta teie serversi 

					<i>(antud näites kasutame selleks veebilehe web.zone.ee/hmvc juurkasuta)</i></p>

					<p>Järgmiseks laadige viimane versioon wiredesignz CodeIgniteri HMVC laiendusest mille leiate <a href='https://bitbucket.org/wiredesignz/codeigniter-modular-extensions-hmvc/get/codeigniter-3.x.zip' target='_blank'>https://bitbucket.org/wiredesignz/codeigniter-modular-extensions-hmvc/get/codeigniter-3.x.zip</a> ning kopeerige kaustad: third_party ja core juba eelnevalt paigaldatud CodeIgniteri kausta <b>application</b>.</p>

					<p>Avage kaustas application kaust <b>core</b> kus te peaksite nägema kahte faili: MY_Loader.php ja MY_Router.php; loome sinna uue faili ja nimetame ta <b>MY_Controller.php</b> avage äsjaloodud fail ning määrake tema sisuks järgmine kood:</p>

					<pre><code class='php'>&lt;?php if (!defined('BASEPATH')) exit('No direct script access allowed');



						# load the MX_Router class

						require APPPATH . "third_party/MX/Controller.php";



						class MY_Controller extends MX_Controller {

							

							function __construct()

							{

								parent::__construct();

							}

							

						}</code></pre>

					<p>Viimaks lisage käsitsi kasuta application kaust nimega <b>modules</b>. Sellega on installatsioon lõpetatud. </p>

					

					<a name='setup'></a>

					<h2>Seadistamine</h2>

					<p>Esmane seadistus kujutab endast <b>config.php</b> avamist kaustas <i>application/config/config.php</i>. Real 20 leiate seadistuse base_url. Muudame antud seadistuse vastavalt olukorrale. Meie näite puhul on seadistus märgitud kommentaarina // meie seadistused.

						<pre><code class='php'>$config['base_url'] = ''; // $config['base_url'] = 'http://web.zone.ee/hmvc/';</code></pre>

					<p>Oleme endiselt samas failis ning suundume järgmise seadistuseni milleks on index_page väärtusega index.php. Kui te ei taha, et teie URL algaks igavesti index.php<i>/minu/tavaar</i> siis seame too tühjuseks.</p>

					<div class='alert alert-info'><b>Teadmiseks!</b> Limiteeritud serverites näiteks <b>web.zone.ee</b>-s ei lubata .htaccess kasutamist mille tõttu on võimatu skippida index.php'd aadressi realt, vaadake [ <a href='http://web.zone.ee/hmvc/tutorial'>siin</a> ]. [ <a href='http://web.zone.ee/hmvc/index.php/tutorial'>Koos index.php</a> ]-ga toimib kõik ilusti. </div>

						<pre><code class='php'>$config['index_page'] = 'index.php'; // $config['index_page'] = '';</code></pre>

					<p>Seadistame session parameetrid. Selleks on meil vaja luua uus kaust, antud näites loome juurkasuta uue kausta nimega <b>sessions</b> ning suundume config.php failis reale 361 ning muudame seadistust järgnevalt:</p>

					<pre><code class='php'>$config['sess_driver'] = 'files';

						$config['sess_cookie_name'] = 'ci_session';

						$config['sess_expiration'] = 7200;

						$config['sess_save_path'] = NULL; // $config['sess_save_path'] = FCPATH . 'sessions';

						$config['sess_match_ip'] = FALSE; // $config['sess_match_ip'] = TRUE;

						$config['sess_time_to_update'] = 300;

						$config['sess_regenerate_destroy'] = FALSE;</code></pre>

					<div class='alert alert-warning'><b>Hoiatus!</b> Kui asute limiteeritud veebiruumis nagu on web.zone.ee siis peate tegema järgnevad muudatused: failis system/core/CodeIgniter.php ja failis index.php kommenteerige välja kõik read tervikuna mis käsitlevad funktsiooni <b>ini_set()</b>;</div>

					<p> Pärast üldise süsteemi seadistust loome uue faili põhi index.php kõrvale <i>(meie näite puhul juurkausta)</i> ning nimetame selle <b>.htaccess</b> failiks mille sisuks seame: </p>

					<pre><code class='apache'>RewriteEngine on

						RewriteBase /



						# If your default controller is something other than

						# 'home' you should probably change this

						RewriteRule ^(home(/index)?|index(\.php)?)/?$ / [L,R=301]

						RewriteRule ^(.*)/index/?$ $1 [L,R=301]



						# Removes trailing slashes (pervents SEO duplicate content issues)

						RewriteCond %{REQUEST_FILENAME} !-d

						RewriteRule ^(.+)/$ $1 [L,R=301]



						# Enforce NO www ( JUHUL KUI EI SOOVI WWW PREFIXI ) ------

						RewriteCond %{HTTP_HOST} ^www [NC]

						# ---------- TEIE VEEBILEHE AADRESS ILMA WWW-TA ---------- 

						RewriteRule ^(.*)$ http://web.zone.ee/hmvc/$1 [L,R=301]

						# --------------------------------------------------------



						# Checks to see if user is attempting to access a valid file,

						# such as image or css document, if this isn't true it sends the# request to index.php

						RewriteCond %{REQUEST_FILENAME} !-f

						RewriteCond %{REQUEST_FILENAME} !-d

						RewriteRule ^(.*)$ /index.php/$1 [L]</code></pre>

					

					<a name='hmvc'></a>

					<h2>MX Liides (HMVC)</h2>

					<p>HMVC liides on meil juba eelnevalt paigaldatud, siinkohal testime tema töövõimekust. Suundume meiepoolt loodud kausta <b>modules</b> ning loome sinna kausta <b>test</b> mille sisse loome omakorda kolm kausta: controllers, models, views.</p>

					<p>Alustame kontrollerist. Suundume äsja loodud kasuta controllers ning loome sinna faili <b>Test.php</b> paneme tähele, et failinimi on suure algustähega! Faili sisse kirjutame järgmise koodi:</p>

					<pre><code class='php'>&lt;?php

						defined('BASEPATH') OR exit('No direct script access allowed');

						

						# Paneme tähele: klassi nimed on suurte algustähtedega!

						class Test extends MY_Controller {



							function index()

							{

								$this->load->view('view_test');

							}

						}

						?&gt;</code></pre>

					<p>Järgmiseks loome view faili. Suundume äsja loodud kausta views ning loome uue faili nimega <b>view_test.php</b> mille sisse kirjutame ükskõik mida, näiteks:</p>

					<pre><code class='php'>CI HMVC Testimiseks!</code></pre>

					<p>Selles näites me models kausta ei käsitle vaid suundume otse <i>/application/views/<b>welcome_message.php</b></i> kustutame tema sisu ning asendame selle koodiga:</p>

					<pre><code class='php'>&lt;?php

						defined('BASEPATH') OR exit('No direct script access allowed');



						# Käivitame HMVC

						# Tähelepanu: Kõik pathid ja nimed Modules::run käsud peavad olema lowercase!

						echo Modules::run('test');

						?&gt;</code></pre>

					<p>Minnes kodulehe indexile ja nähes vastust "CI HMVC Testimiseks!" oleme veendunud, et CodeIgniter HMVC on täiesti töökorras.</p>

					

					<a name='fsql-ci-driver'></a>

					<h2>fSQL CodeIgniter Library</h2>

					<p>Juhul mil sooviksite kasutada andmebaasivõimalust kus teda tegelikkuses ette nähtud ei ole: Tõstsin fSQL 1.3.1 CodeIgniteri stiilile üle. <a href='/hmvc/fSQL.1.3.1-Codeigniter-library.zip'>Laadige fSQL CodeIgniter jaoks siit</a>. Asetage arhiivis olev kaust <b>Fsql</b> kausta <i>application/libraries/</i> ning looge kausta <i>application/core</i> uus fail nimega <b>MY_Model.php</b> seejärel seage tema sisu järgnevaks:<p>

					<pre><code class='php'>&lt;?php

						defined('BASEPATH') OR exit('No direct script access allowed');



						class MY_Model extends CI_Model {



							function __construct()

							{

								# Load parent functions

								parent::__construct();

								

								# Loome ühenduse fSQL liidesega.

								$this->load->library('fsql');

								$this->fsql->define_db('db001', FCPATH . 'db/db001');

								$this->fsql->select_db('db001');

							}

							

						}

						?&gt;</code></pre>

					<p>Viimaks loome kaks kausta, kuhu meie andmeid hakatakse salvestama: index.php kõrvale (meie näite puhul juurkausta) loome kasuta <b>db</b> ning kausta db sisse loome andmebaasi kausta <b>db001</b>. Pärast seda saate kasutada fSQL liidest täpselt samuti kuis lehel <a href='http://web.zone.ee/fsql/#benchmark' target='_blank'>http://web.zone.ee/fsql/</a> lõigus kiirustest alates punktist 2 <i>( Loome tabeli... )</i> </p>

					

					<a name='contact'></a>

					<h2>Kontakt</h2>

					<p>

						Võtke ühendust e-posti teel info@joonaskolostov.ee<br>

						kirjutage facebooki kasutajale Joonas Kolostov<br>

						<hr>

						<?=date('Y-m-d H:i:s');?>

					</p>

				</div>

			</div>

		</div>

	</body>

</html>

